<?php

namespace Drupal\commerce_user_points;

/**
 * Get Referral link.
 *
 * @package Drupal\referrallink
 * Class ReferralLinkService.
 */
class ReferralLinkService {

  /**
   * Get valid Referral link.
   */
  public function getLink($field, $value = NULL) {
    $query = \Drupal::database()->select('user_points_referral', 'upr')
      ->fields('upr', ['referral_link_code'])
      ->condition('upr.' . $field . '', $value);
    $result = $query->execute()->fetchAssoc();
    return $result;
  }

  /**
   * Get valid Referral link.
   */
  public function getLinkUser($value = NULL) {
    $query = \Drupal::database()->select('user_points_referral', 'upr')
      ->fields('upr', ['uid'])
      ->condition('upr.referral_link_code', $value);
    $result = $query->execute()->fetchAssoc();
    return $result;
  }

  /**
   * Get add Referral link.
   */
  public function addLink($uid = NULL) {
    $link = "";
    $chars = "0123456789abcdefghijklmnopqrstuvwxyz";
    for ($i = 0; $i < 20; $i++) {
      $link .= $chars[mt_rand(0, strlen($chars) - 1)];
    }

    // Inesert in database.
    \Drupal::database()->insert('user_points_referral')->fields([
      'uid' => $uid,
      'referral_link_code' => $link,
      'timestamp' => \Drupal::time()->getRequestTime(),
      'status' => 'valid',
    ])->execute();
  }

}
